<?php
require_once('Utility.php');

$merchant_id = $_POST['merchantid'];
$merchant_key = $_POST['merchantKey'];
$url = 'https://api.iotpaycloud.com/v1/create_order';
$channelId = $_POST['channelid'];
$order_amount = $_POST['orderamount'];
$order_sn = $_SERVER['REQUEST_TIME'];
$codevalue = $_POST['barcode'];
$jobNo = $_POST['jobNo'];
$Utility = new Utility();
$ip = $Utility->real_ip();
$notifyUrl = 'https://develop.iotpay.ca/newdemo/scan/notify.php';
$subject = 'test';
$body = 'paytest';
$sceneInfo = '';//Additional parameters when a specific channel is initiated, see below
if ($channelId == 'WX_MICROPAY') {
    $sceneInfo = array(
        'productId' => $merchant_id . $order_sn,
    );
    $sceneInfo = json_encode($sceneInfo);
}
$arr = array(
    'mchId' => $merchant_id,
    'mchOrderNo' => $order_sn,
    'extra' => $sceneInfo,
    'channelId' => $channelId,
    'currency' => 'CAD',
    'amount' => intval($order_amount * 100),
    'clientIp' => $ip,
    'notifyUrl' => $notifyUrl,
    'subject' => $subject,
    'body' => $body,
    'codeType' => 'barcode',
    'identityCode' => $codevalue
);
if($jobNo){
  $arr['jobNo'] = $jobNo;
}
$sort_array = $Utility->arg_sort($arr);
$arr['sign'] = $Utility->build_mysign($sort_array, $merchant_key, "MD5");//Generate signature parameter sign
$param = 'params=' . json_encode($arr);
$resBody = $Utility->request($url, $param);//Submit to the gateway
$outputres = "res: " . $resBody;;
$res = json_decode($resBody, true);
if ($res['retCode'] == 'SUCCESS' && $res['resCode'] == 'SUCCESS') {
  $status = "Payment successfully";
  if($res['payOrder']['status']==1){
    $url = 'https://api.iotpaycloud.com/v1/query_order';
    $arr = array(
        'mchId' => $merchant_id,
        'mchOrderNo' => $res['payOrder']['mchOrderNo'],
        'payOrderId' => '',
    );
    $sort_array = $Utility->arg_sort($arr);
    $arr['sign'] = $Utility->build_mysign($sort_array, $merchant_key, "MD5");//Generate signature parameter sign
    $param = 'params=' . json_encode($arr);
    $i = 0;
    do {
        $i++;
        if ($i > 10) {
            $status = 'Order payment failed!';
            $msg = 'query time out!';
            break;
        }
        $resBody = $Utility->request($url, $param);
        $query_res = json_decode($resBody, true);
        sleep(2);
    } while (!($query_res['retCode'] == 'SUCCESS' && $query_res['resCode'] == 'SUCCESS' && ($query_res['result']['status'] == '2')));
  }
} else {
    $status = 'Order payment failed!';
    $msg = $res['retMsg'] . $res['errCodeDes'];
}
?>
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=no">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>IoT-Pay - Web Payment In WeChat Test</title>
    <link rel="icon" type="image/png" href="https://develop.iotpay.ca/imgs/favicon64x64.png">
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css"
          integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T"
          crossorigin="anonymous">
</head>
<body>
<nav class="navbar navbar-expand-lg navbar-light bg-light">
    <a class="navbar-brand mx-auto" href="#">
        <img src="https://develop.iotpay.ca/imgs/iot-logo.png" height="50" alt="">
    </a>
</nav>
<div class="container">
    <div class="col-xl-8 mx-auto py-5">
        <div class="form-group">
            <div style="text-align: center"><h1><?php echo $status ?></h1></div>
        </div>
        <div class="form-group"><?php echo $msg ?></div>
        <div class="form-group row">
            <input type="button" class="btn btn-primary btn-block mt-5" value="Return"
                   onclick="location.href = 'demo.html'"/>
        </div>
    </div>
</div>
</body>
</html>